#define fbext_NoBuiltinInstanciations() 1

#include once "ext/containers/list.bi"
#include once "ext/strings/strsplit.bi"
#include once "ext/strings/strmanip.bi"
#include once "ext/options.bi"
#include once "ext/misc.bi"
#include once "inc/compiler.bi"
#include once "inc/module.bi"
#include once "file.bi"
#include once "dir.bi"


fbext_Instanciate( fbExt_List, ((compiler)) )
fbext_Instanciate( fbExt_List, ((module)) )


#include once "inc/parser.bi"


using ext

#define FAKEFILENAME "fakefile"
#ifdef __fb_linux__
#define SLASH "/"
#define EXE_EXT ""
#define DLL_EXT ".so"
#else
#define SLASH "\"
#define EXE_EXT ".exe"
#define DLL_EXT ".dll"
#endif

dim shared as string gFakefile
dim shared as string gModToBuild
dim shared as string gCurDir

declare sub printstatus( byval numtoadd as uinteger = 0 )
declare function findmod( byref search as const string, byval mods as modlist ptr ) as const module ptr
declare function dobuild( byval mtb as const module ptr, byval allmods as modlist ptr ) as integer

gCurDir = curdir()
gFakefile = gCurDir & SLASH & FAKEFILENAME
gModToBuild = ""

var iOpts = options.Parser
iOpts.setHelpHeader(!"fake - The (not just) FreeBASIC build system.\nCopyright 2010 Ebben Feagan http://mud.owlbox.net")
var v = iOpts.addBool("v","version","Display the program's version.")
var vv = iOpts.addBool("cc","copyright","Display the program's copyright.")
var f = iOpts.addOption("f","file",true,,,,!"File to use instead of the default \"fakefile\".")
var c = iOpts.addBool("c","clean","Removes any intermediate files generated by the build process.")
var d = iOpts.addBool("cd","delete","Removes all files generated by fake including executables and libraries.")
var g = iOpts.addBool("g","debug","Build with debug information. Add's -g to [GLOBAL]'s options in practice.")
var ag =iOpts.addOption("a","auto",true,,,,!"Attempt to automatically generate a fakefile for\n the extension passed for files in the current directory only.")
var m = iOpts.addOption("am","auto-main",true,,,,"Used with -a/--auto to set the main file in an executable, use no extension.")
var o = iOpts.addOption("ao","auto-output",true,,,,"Used with -a/--auto to set the output file, use no extension. (optional)")
var t = iOpts.addOption("at","auto-type",true,,,,!"Used with -a/--auto to set the output type, defaults to 'exe' (optional).\nOptions are: exe, console, gui, dylib and static")
iOpts.setHelpFooter(!"Additional help using fake can be found by reading \n\"format.txt\" distributed with fake.\nfake is Free Software distributed under the terms of the BSD license.")

iOpts.parse( __fb_argc__, __fb_argv__ )

if (iOpts.isSet(ag) andalso (not iOpts.isSet(m))) orelse _
        (iOpts.isSet(ag) andalso (not iOpts.isSet(o))) then
        ? "ERROR: You must specify at least a main file (-am,--auto-main) or an output file (-ao,--auto-output) or both."
        end __line__
endif

if iOpts.isSet(ag) andalso (iOpts.isSet(m) orelse iOpts.isSet(o)) then

        var agext = iOpts.getArg(ag)
        if agext = "" then
                ? "ERROR: no extension specified for auto-generation."
                end __line__
        endif
        var am = ""
        var ao = ""
        if iOpts.isSet(m) then am = iOpts.getArg(m)
        var at = "exe"
        if fileexists(gFakefile) then
                ? "ERROR: fakefile already exists."
                end __line__
        endif
        if iOpts.isSet(o) then
                ao = iOpts.getArg(o)
        else
                ao = am
        endif
        if iOpts.isSet(t) then
                at = iOpts.getArg(t)
        endif


        open "fakefile" for binary access write as #1
        print #1, "#Generated Automagically by fake .99b"
        print #1, "#Edit this file to you heart's content."
        print #1, using "[&]"; ao
        print #1, "files = ";
        var outstr = ""
        for n as misc.FILE_ITER = misc.FILE_ITER("*." & agext, fbNormal ) to ""
                outstr = outstr & n.filename & ", "
        next
        outstr = left(trim(outstr),len(outstr)-2)
        print #1, outstr
        print #1, using "type = &"; at
        print #1, using "output = &"; ao
        if iOpts.isSet(m) then
                print #1, using "main = &"; am
        endif

        print #1, "#depends = enter dependencies here seperated by comma and remove this comment and #"
        close #1

endif


if iOpts.isSet(v) then
        ? "fake - The (not just for) FreeBASIC build system."
        ? "Version: fake .99b"
        ? "Built with:" & __FB_SIGNATURE__
        ? "Uses " & FBEXT_VERSION_STRING
        end 0
endif

if iOpts.isSet(vv) then
        ? "fake - The (not just for) FreeBASIC build system."
        ? "Copyright (c) 2010, Ebben Feagan <sir@mud.owlbox.net>"
        ? "All rights reserved."
        ?
        ? "Redistribution and use in source and binary forms, with or without"
        ? !"modification, are permitted provided that the following conditions\n are met:"
        ?
        ? "Redistributions of source code must retain the above copyright"
        ? "notice, this list of conditions and the following disclaimer."
        ?
        ? "Redistributions in binary form must reproduce the above copyright"
        ? "notice, this list of conditions and the following disclaimer in the"
        ? "documentation and/or other materials provided with the distribution."
        ?
        ? "Neither the name of the HMCsoft nor the names of its contributors may"
        ? "be used to endorse or promote products derived from this software without"
        ? "specific prior written permission."
        ?
        ? !"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"as is\""
        ? "AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE "
        ? "IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE"
        ? "DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE "
        ? "FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL "
        ? "DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR "
        ? "SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER "
        ? "CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,"
        ? "OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF"
        ? "THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
        ?
        end 0
endif


if iOpts.isSet(f) then
        gFakefile = iOpts.getArg(f)

endif

if iOpts.isSet(c) then
        GLOBALS.clean = true
endif
if iOpts.isSet(d) then
        GLOBALS.dele = true
endif

gModToBuild = iOpts.getRemainder()


if not(fileexists(gFakefile)) then
        ? "ERROR: Unable to locate " & gFakefile
        ? "*** Build can not proceed. ***"
        end __line__
endif

parser_init()

'have to set this after parser_init because it clears GLOBALS.options
if iOpts.isSet(g) then
        GLOBALS.options = "-g"
endif

var mods = parse_fakefile(gFakefile)
if mods = 0 then
        ? "ERROR: Unknown error parsing " & gFakefile
        ? "*** Try finding an old priest and a young priest. ***"
        end __line__
endif
if mods->Size = 0 then
        ? "ERROR: No Modules specified in " & gFakefile
        ? "*** Maybe you have to blow in it like a Nintendo? ***"
        end __line__
endif

var thismod = findmod(gModToBuild,mods)
if GLOBALS.dele = true orelse GLOBALS.clean = true then
print "Cleaning Up... [  0%]"
else
print "Compiling... [  0%]"
endif
if (not GLOBALS.clean) then printstatus(1)
var ret = dobuild(thismod, mods)
if ret <> 0 then
        ? "Error during Build."
endif


while true
        printstatus 'ensures it gets to 100%
wend


'** END OF MAIN

function findmod( byref search as const string, byval mods as modlist ptr ) as const module ptr

        if search = "" then

                var iter = mods->Begin()

                return iter.get()

        endif


        var iter = mods->Begin()

        while iter <> mods->End_()

                var x = iter.Get()

                if x->name = search then return x

                iter.Increment

        wend

        ? "ERROR: Module: & not found in fakefile: &"; search, gFakefile
        ? "*** Build can not proceed. ***"
        end __line__
        return 0

end function

function findcompiler( byref x as const string ) as const compiler ptr

        static as string lastx
        static as compiler ptr lastc
        static as bool doit = true

        if doit = false andalso lastx = x then
                return lastc
        end if

        var iter = COMPILERS.Begin()

        while iter <> COMPILERS.End_()
                var z = iter.get()
                if z->extensions = x then

                        #ifdef __fb_win32__
                        z->name = environ(z->name)
                        #endif
                        lastx = x
                        lastc = z
                        doit = false
                        return z
                endif

                iter.Increment
        wend

        return 0

end function

sub printstatus( byval numtoadd as uinteger = 0 )

        static numtotal as uinteger = 0
        static numleft as uinteger = 0

        if numtoadd <> 0 then
                numtotal += numtoadd
        else
                numleft += 1
                var t = int((numleft/numtotal)*100)
                if t>100 then
                        end 0
                endif
                locate csrlin-1,1
                if GLOBALS.dele = true orelse GLOBALS.clean = true then
                        print using "Cleaning Up... [###%]";t
                else
                        print using "Compiling... [###%]";t
                endif

        endif

end sub


sub compile( byref fi as const string, byref fo as const string, byval m as const module ptr, byval c as const compiler ptr, byref mf as const string )

        var compile_str = ""


        if GLOBALS.clean = true orelse GLOBALS.dele = true then
                kill fo
                printstatus
                return
        endif


        if fileexists(fo) = 0 orelse filedatetime(fi) > filedatetime(fo) then

                compile_str = c->compile_opts
                strings.replace(compile_str,"$in",fi)
                strings.replace(compile_str,"$out",fo)
                strings.replace(compile_str,"$opts", GLOBALS.options & " " & m->c_opts)
                strings.replace(compile_str,"$main", " -m " & mf)
                '? c->name & " " & trim(compile_str)
                var ret = exec( c->name & EXE_EXT, trim(compile_str) )
                if ret > 0 then
                        ? "ERROR: Building " & fi & " failed."
                        end ret
                elseif ret = -1 then

                        ? "ERROR: Unable to locate compiler, try setting environment variable: " & c->name
                        end __line__
                endif
                printstatus

        endif



end sub

function dobuild( byval mtb as const module ptr, byval allmods as modlist ptr ) as integer

        if (not GLOBALS.clean) then printstatus(1)

        if mtb->depends <> "" andalso GLOBALS.clean <> true andalso GLOBALS.dele <> true then
                'got to build dependancies first

                dim dependd() as string
                strings.explode(mtb->depends,",",dependd())
                if (not GLOBALS.clean) then printstatus(ubound(dependd))
                for n as integer = lbound(dependd) to ubound(dependd)
                        var grue = findmod(dependd(n),allmods)
                        if grue = 0 then
                                ? using !"ERROR: Unable to locate dependancy \"&\" for module \"&\""; dependd(n),mtb->name
                                end __line__
                        endif
                        var fjai = dobuild(grue,allmods)
                        if fjai <> 0 then
                                ? using !"ERROR: Unable to build dependancy \"&\" for module \"&\""; dependd(n),mtb->name
                                end __line__
                        endif
                next n


        endif

        if GLOBALS.builddir <> "" andalso GLOBALS.clean <> true andalso GLOBALS.dele <> true then
                mkdir GLOBALS.builddir
        endif


        dim files() as string
        dim files_o() as string

        var type_ = mtb->type_

        if left(mtb->files,1) = "(" then
                ? "not implemented atm"
        endif

        strings.explode(mtb->files,",",files())
        printstatus(ubound(files))

        redim files_o(ubound(files))

        var mainf = left(files(0),instr(files(0),".")-1)
        if mtb->main_ <> "" then mainf = mtb->main_

        for n as integer = lbound(files) to ubound(files)
                var cext = right(files(n),len(files(n))-instr(files(n),"."))

                files_o(n) = left(files(n),len(files(n))-len(cext)) & "o"
                strings.replace(files_o(n), SLASH, "_")
                if GLOBALS.builddir <> "" then
                        files_o(n) = GLOBALS.builddir & SLASH & trim(files_o(n))
                end if

                var comp = findcompiler(cext)
                if comp = 0 then
                        ? "ERROR: Compiler not found for extension: " & cext
                        return __line__
                endif

                compile( files(n), files_o(n), mtb, comp, mainf )
        next n

        var olist = strings.join(files_o()," ")

        var compiler_str = ""
        var comp = findcompiler(right(files(0),len(files(0))-instr(files(0),".")))
        if comp = 0 then
                ? "ERROR: Default compiler not found for module: " & mtb->name
                return __line__
        endif
        select case type_
                case mtype.exe
                        compiler_str = comp->link_opts
                        strings.replace(compiler_str,"$main"," -m " & mainf)
                case mtype.console
                        compiler_str = comp->link_opts
                        strings.replace(compiler_str,"$opts","$opts -s console")
                        strings.replace(compiler_str,"$main"," -m " & mainf)
                case mtype.gui
                        compiler_str = comp->link_opts
                        strings.replace(compiler_str,"$opts","$opts -s gui")
                        strings.replace(compiler_str,"$main"," -m " & mainf)

                case mtype.dylib
                        compiler_str = comp->dylib_opts

                case mtype.static_
                        compiler_str = comp->static_opts

        end select

        var repopts = trim(GLOBALS.options & " " & mtb->c_opts)
        strings.replace(compiler_str,"$opts", repopts)
        strings.replace(compiler_str,"$ins",olist)
        
        if mtb->output_ = "" then
                select case type_
                        case mtype.exe, mtype.console, mtype.gui
                                strings.replace(compiler_str,"$out",mtb->name & EXE_EXT)
                        case else
                                strings.replace(compiler_str,"$out",mtb->name )
                end select

        else
                select case type_
                        case mtype.exe, mtype.console, mtype.gui
                                strings.replace(compiler_str,"$out",mtb->output_ & EXE_EXT)
                        case else
                                strings.replace(compiler_str,"$out",mtb->output_ )
                end select
        endif

        if GLOBALS.dele = true then
                printstatus
                select case type_
                        case mtype.exe, mtype.console, mtype.gui
                                if mtb->output_ = "" then
                                        kill mtb->name & EXE_EXT
                                else
                                        kill mtb->output_ & EXE_EXT
                                endif
                        case mtype.dylib
                                if mtb->output_ = "" then
                                        kill "lib" & mtb->name & dll_EXT
                                else
                                        kill "lib" & mtb->output_ & dll_EXT
                                endif
                        case mtype.static_
                                if mtb->output_ = "" then
                                        kill "lib" & mtb->name & ".a"
                                else
                                        kill "lib" & mtb->output_ & ".a"
                                endif
                end select

        elseif GLOBALS.clean <> true andalso GLOBALS.dele <> true then
                '? comp->name & " " & trim(compiler_str)
                var ret = exec(comp->name & EXE_EXT, trim(compiler_str))
                printstatus
                return ret
        endif
        return 0



end function
